require "ui.globals"
require "ui.config"
require "ui.colors"
require "ui.init"
require "ui.draw"
require "ui.keyboard"
require "ui.mouse"
require "sudoku.utils"

function love.load()
    love.window.setTitle("Sudoku!")
    love.window.setMode(0, 0)
    love.mouse.setGrabbed(false)
    love.keyboard.setKeyRepeat(true)
    math.randomseed(os.time())
    messages[1] = "Game Info"
    board[1] = loadBoard(board.fn)
    board[2] = cloneBoard(board[1])
    initUI()
end

function love.update(dt)
end

function love.draw()
    setBackgroundColor(colors.backGround)
    drawGrid()
    drawSmallNumbers()
    drawBigNumbers()
    drawCursor()
    drawMessages()
end
